//
//  SAAudioAvailabilityRange.swift
//  SwiftAudioPlayer
//
//  Created by Tanha Kabir on 2019-02-18.
//  Copyright © 2019 Tanha Kabir, Jon Mercer
//
//  Permission is hereby granted, free of charge, to any person obtaining a copy
//  of this software and associated documentation files (the "Software"), to deal
//  in the Software without restriction, including without limitation the rights
//  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//  copies of the Software, and to permit persons to whom the Software is
//  furnished to do so, subject to the following conditions:
//
//  The above copyright notice and this permission notice shall be included in
//  all copies or substantial portions of the Software.
//
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//  THE SOFTWARE.

import Foundation

//Think of it as the grey buffer line from youtube
public struct SAAudioAvailabilityRange {
    let startingNeedle: Needle
    let durationLoadedByNetwork: Duration
    let isPlayable: Bool
    
    public var startingBufferTimePositon: Double {
        get {
            return startingNeedle
        }
    }
    
    public var totalDurationBuffered: Double {
        get {
            return durationLoadedByNetwork
        }
    }
    
    public var isReadyForPlaying: Bool {
        get {
            return isPlayable
        }
    }
    
    public func contains(_ needle: Double) -> Bool {
        return needle >= startingNeedle && (needle - startingNeedle) < durationLoadedByNetwork
    }
}
